epm-sh-functions 13.7 KB
Newer Older
Vitaly Lipatov's avatar
Vitaly Lipatov committed
1 2
#!/bin/sh
#
3 4
# Copyright (C) 2012, 2014  Etersoft
# Copyright (C) 2012, 2014  Vitaly Lipatov <lav@etersoft.ru>
Vitaly Lipatov's avatar
Vitaly Lipatov committed
5
#
6 7 8
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
Vitaly Lipatov's avatar
Vitaly Lipatov committed
9 10 11 12 13
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14
# GNU Affero General Public License for more details.
Vitaly Lipatov's avatar
Vitaly Lipatov committed
15
#
16 17
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
Vitaly Lipatov's avatar
Vitaly Lipatov committed
18 19
#

20
# copied from /etc/init.d/outformat (ALT Linux)
21

22 23
check_core_commands()
{
24 25 26 27 28
	#which --help >/dev/null || fatal "Can't find which command (which package is missed?)"
	# broken which on Debian systems
	which which >/dev/null || fatal "Can't find which command (which or debianutils package is missed?)"
	which grep >/dev/null || fatal "Can't find grep command (coreutils package is missed?)"
	which sed >/dev/null || fatal "Can't find sed command (sed package is missed?)"
29 30 31
}


32
# FIXME on Android: FIX ME! implement ttyname_r() bionic/libc/bionic/stubs.c:366
33 34 35
inputisatty()
{
	# check stdin
36 37
	#tty -s 2>/dev/null
	test -t 0
38 39
}

40 41
isatty()
{
42 43 44 45 46 47
	# check stdout
	test -t 1
}

isatty2()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
48 49
	# check stderr
	test -t 2
50 51
}

52 53
check_tty()
{
54 55 56 57 58 59
	isatty2 || return

	# Set a sane TERM required for tput
	[ -n "$TERM" ] || TERM=dumb
	export TERM

60 61
	check_core_commands

Vitaly Lipatov's avatar
Vitaly Lipatov committed
62 63
	# grep -E from busybox may not --color
	# grep -E from MacOS print help to stderr
Vitaly Lipatov's avatar
Vitaly Lipatov committed
64
	if grep -E --help 2>&1 | grep -q -- "--color" ; then
65
		export EGREPCOLOR="--color"
66 67
	fi

68 69 70 71
	which tput >/dev/null 2>/dev/null || return
	# FreeBSD does not support tput -S
	echo | tput -S >/dev/null 2>/dev/null || return
	[ -z "$USETTY" ] || return
72 73 74
	export USETTY=1
}

75 76 77 78
: ${BLACK:=0} ${RED:=1} ${GREEN:=2} ${YELLOW:=3} ${BLUE:=4} ${MAGENTA:=5} ${CYAN:=6} ${WHITE:=7}

set_boldcolor()
{
79
	[ "$USETTY" = "1" ] || return
80 81 82 83 84 85 86 87
	{
		echo bold
		echo setaf $1
	} |tput -S
}

restore_color()
{
88
	[ "$USETTY" = "1" ] || return
89 90 91 92 93 94
	{
		echo op; # set Original color Pair.
		echo sgr0; # turn off all special graphics mode (bold in our case).
	} |tput -S
}

Vitaly Lipatov's avatar
Vitaly Lipatov committed
95 96
echover()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
97
    [ -z "$verbose" ] && return
98
    echo "$*" >&2
Vitaly Lipatov's avatar
Vitaly Lipatov committed
99 100
}

101 102 103
# echo string without EOL
echon()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
104
	# default /bin/sh on MacOS does not recognize -n
Vitaly Lipatov's avatar
Vitaly Lipatov committed
105
	/bin/echo -n "$*"
106 107 108
}


Vitaly Lipatov's avatar
Vitaly Lipatov committed
109 110 111
# Used DISTRNAME
set_target_pkg_env()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
112
	[ -n "$DISTRNAME" ] || fatal "Missing DISTRNAME in set_target_pkg_env."
113 114 115 116 117
	local ver="$DISTRVERSION"
	[ -n "$ver" ] && ver="/$ver"
	PKGFORMAT=$($DISTRVENDOR -p "$DISTRNAME$ver")
	PKGVENDOR=$($DISTRVENDOR -s "$DISTRNAME$ver")
	RPMVENDOR=$($DISTRVENDOR -n "$DISTRNAME$ver")
Vitaly Lipatov's avatar
Vitaly Lipatov committed
118 119 120
}

# Print command line and run command line
121
showcmd()
Vitaly Lipatov's avatar
Vitaly Lipatov committed
122
{
123 124 125
	if [ -z "$quiet" ] ; then
		set_boldcolor $GREEN
		local PROMTSIG="\$"
126
		is_root && PROMTSIG="#"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
127
		echo " $PROMTSIG $*"
128
		restore_color
129
	fi >&2
130 131
}

132 133 134 135 136 137 138 139 140 141
# Print command
echocmd()
{
	set_boldcolor $GREEN
	local PROMTSIG="\$"
	is_root && PROMTSIG="#"
	echo -n "$PROMTSIG $*"
	restore_color
}

142 143 144
# Print command line and run command line
docmd()
{
Vitaly Lipatov's avatar
Vitaly Lipatov committed
145
	showcmd "$*$EXTRA_SHOWDOCMD"
146
	"$@"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
147 148
}

149
# Run every arg with docmd
150 151
docmd_foreach()
{
152
	local cmd pkg
153 154 155 156
	cmd="$1"
	#showcmd "$@"
	shift
	for pkg in "$@" ; do
157
		docmd $cmd $pkg
158 159 160
	done
}

161 162 163 164
# run command line with SUDO
sudorun()
{
	set_sudo
Vitaly Lipatov's avatar
Vitaly Lipatov committed
165
	if [ -z "$SUDO" ] ; then
166
		"$@"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
167 168 169
		return
	fi
	$SUDO "$@"
170 171
}

172
# Print command line and run command line with SUDO
173
sudocmd()
174
{
175
	set_sudo
176
	[ -n "$SUDO" ] && showcmd "$SUDO $*" || showcmd "$*"
177
	sudorun "$@"
178 179
}

180
# Run every arg with sudocmd
181
# Returns on any error
182 183
sudocmd_foreach()
{
184
	local cmd pkg
185 186 187 188
	cmd="$1"
	#showcmd "$@"
	shift
	for pkg in "$@" ; do
189 190
		# don't quote $cmd here: it can be a command with an args
		sudocmd $cmd $pkg || return
191 192 193
	done
}

194 195 196 197 198 199 200 201
# add realpath if missed
if ! which realpath 2>/dev/null >/dev/null ; then
realpath()
{
	readlink -f "$@"
}
fi

202 203 204 205 206 207 208 209 210 211 212
# print full path to files
make_filepath()
{
	local i
	for i in "$@" ; do
		[ -f "$i" ] || continue
		echo "$i" | grep -q "/" && echo "$i" && continue
		echo "./$i"
	done
}

213 214
get_firstarg()
{
215
	echon "$1"
216 217 218 219 220
}

get_lastarg()
{
	local lastarg
Vitaly Lipatov's avatar
Vitaly Lipatov committed
221
	eval "lastarg=\${$#}"
222
	echon "$lastarg"
223 224
}

225 226 227 228 229 230
# TODO: see etersoft-build-utils/tests/test_isnumber.sh
isnumber()
{
	echo "$*" | filter_strip_spaces | grep -q "^[0-9]\+$"
}

Vitaly Lipatov's avatar
Vitaly Lipatov committed
231 232
# copied from strings
# CHECKME: the same like estrlist has ?
Vitaly Lipatov's avatar
Vitaly Lipatov committed
233
# Note: used grep -E! write '[0-9]+(first|two)', not '[0-9]\+...'
Vitaly Lipatov's avatar
Vitaly Lipatov committed
234 235 236 237 238 239 240 241 242 243 244 245
rhas()
{
	echo "$1" | grep -E -q -- "$2"
}

# copied from strings
is_dirpath()
{
    [ "$1" = "." ] && return $?
    rhas "$1" "/"
}

Vitaly Lipatov's avatar
Vitaly Lipatov committed
246 247 248 249 250 251 252 253 254 255 256 257 258
filter_strip_spaces()
{
        # possible use just
        #xargs echo
        sed -e "s| \+| |g" | \
                sed -e "s|^ ||" | sed -e "s| \$||"
}

strip_spaces()
{
        echo "$*" | filter_strip_spaces
}

259 260 261 262 263 264
# param true false
subst_option()
{
	eval "[ -n \"\$$1\" ]" && echo "$2" || echo "$3"
}

265 266 267 268
store_output()
{
    # use make_temp_file from etersoft-build-utils
    RC_STDOUT=$(mktemp)
269 270
    local CMDSTATUS=$RC_STDOUT.pipestatus
    echo 1 >$CMDSTATUS
271
    #RC_STDERR=$(mktemp)
272
    ( LANG=C $@ 2>&1 ; echo $? >$CMDSTATUS ) | tee $RC_STDOUT
Vitaly Lipatov's avatar
Vitaly Lipatov committed
273
    return "$(cat $CMDSTATUS)"
274
    # bashism
275
    # http://tldp.org/LDP/abs/html/bashver3.html#PIPEFAILREF
276
    #return $PIPESTATUS
277 278
}

279 280 281 282 283 284
showcmd_store_output()
{
    showcmd "$@"
    store_output "$@"
}

285 286
clean_store_output()
{
287
    rm -f $RC_STDOUT $RC_STDOUT.pipestatus
288 289
}

290
# run epm, possible from side repo
291 292
epm()
{
293
	if [ -n "$PROGNAME" ] ; then
294
		/bin/sh $PROGDIR/$PROGNAME --inscript "$@"
295 296 297
	else
		epm_main --inscript "$@"
	fi
298 299 300 301 302
}

# run $SUDO epm, possible from side repo
sudoepm()
{
303 304
	[ -n "$PROGNAME" ] || fatal "Can't use sudo epm call from the piped script"
	sudorun /bin/sh $PROGDIR/$PROGNAME --inscript "$@"
305
}
Vitaly Lipatov's avatar
Vitaly Lipatov committed
306 307 308 309 310

# Print error message and stop the program
fatal()
{
	if [ -z "$TEXTDOMAIN" ] ; then
311
		echo "Error: $*  (you can discuss the problem in Telegram: https://t.me/useepm)" >&2
Vitaly Lipatov's avatar
Vitaly Lipatov committed
312 313
#	else
#		echog "Error in $0: $@" >&2
Vitaly Lipatov's avatar
Vitaly Lipatov committed
314
	fi
315
#	[ "$TERM" = "screen" ] && echo "(screen detected: waiting ten seconds to exit ...)" >&2 && sleep 10
Vitaly Lipatov's avatar
Vitaly Lipatov committed
316 317
	exit 1
}
318

Vitaly Lipatov's avatar
Vitaly Lipatov committed
319 320 321 322
# Print warning message
warning()
{
	if [ -z "$TEXTDOMAIN" ] ; then
Vitaly Lipatov's avatar
Vitaly Lipatov committed
323
		echo "Warning: $*" >&2
Vitaly Lipatov's avatar
Vitaly Lipatov committed
324 325 326 327 328
#	else
#		echog "Error in $0: $@" >&2
	fi
}

329 330 331 332
info()
{
	[ -n "$quiet" ] && return

333 334 335
	# print message to stderr if stderr forwarded to (a file)
	if isatty2 ; then
		isatty || return 0
Vitaly Lipatov's avatar
Vitaly Lipatov committed
336
		echo "$*"
337
	else
Vitaly Lipatov's avatar
Vitaly Lipatov committed
338
		echo "$*" >&2
339
	fi
340 341
}

342 343 344
# if we have not sudo, returns 1 and set SUDO variable to fatal
SUDO_TESTED=''
SUDO_CMD='sudo'
345 346
set_sudo()
{
347 348 349 350 351 352
	local nofail="$1"

	# cache the result
	[ -n "$SUDO_TESTED" ] && return "$SUDO_TESTED"
	SUDO_TESTED="0"

353 354 355
	SUDO=""
	# skip SUDO if disabled
	[ -n "$EPMNOSUDO" ] && return
356 357 358 359
	if [ "$DISTRNAME" = "Cygwin" ] || [ "$DISTRNAME" = "Windows" ] ; then
		# skip sudo using on Windows
		return
	fi
360

361
	# if we are root, do not need sudo
362
	is_root && return
363

364 365 366
	# start error section
	SUDO_TESTED="1"

367
	if ! which $SUDO_CMD >/dev/null 2>/dev/null ; then
368 369
		[ "$nofail" = "nofail" ] || SUDO="fatal 'Can't find sudo. Please install and tune sudo ('# epm install sudo') or run epm under root.'"
		return "$SUDO_TESTED"
370
	fi
371

372 373
	# if input is a console
	if inputisatty && isatty && isatty2 ; then
374
		if ! $SUDO_CMD -l >/dev/null ; then
375
			[ "$nofail" = "nofail" ] || SUDO="fatal 'Can't use sudo (only passwordless sudo is supported in non interactive using). Please run epm under root.'"
376
			return "$SUDO_TESTED"
377 378 379
		fi
	else
		# use sudo if one is tuned and tuned without password
380
		if ! $SUDO_CMD -l -n >/dev/null 2>/dev/null ; then
381
			[ "$nofail" = "nofail" ] || SUDO="fatal 'Can't use sudo (only passwordless sudo is supported). Please run epm under root or check http://altlinux.org/sudo '"
382
			return "$SUDO_TESTED"
383
		fi
384 385
	fi

386
	SUDO_TESTED="0"
387 388 389
	# FIXME: does not work: sudo -- VARIABLE=some command
	SUDO="$SUDO_CMD"
	#SUDO="$SUDO_CMD --"
390
	# check for < 1.7 version which do not support -- (and --help possible too)
391
	#$SUDO_CMD -h 2>/dev/null | grep -q "  --" || SUDO="$SUDO_CMD"
392

393 394
}

395 396 397 398 399 400
# return TRUE if we can run privileged command
sudo_allowed()
{
	set_sudo nofail
}

401 402
# wait for n seconds (if possible) during executing command
# args: seconds command
403 404 405
withtimeout()
{
	local TO=$(which timeout 2>/dev/null || which gtimeout 2>/dev/null)
Vitaly Lipatov's avatar
Vitaly Lipatov committed
406
	if [ -x "$TO" ] ; then
407
		$TO "$@"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
408 409
		return
	fi
410
	fatal "Possible indefinite wait due timeout command is missed"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
411
	# fallback: drop time arg and run without timeout
412 413
	#shift
	#"$@"
414 415
}

416 417
set_eatmydata()
{
418 419
	# don't use eatmydata (useless)
	return 0
420 421 422 423
	# skip if disabled
	[ -n "$EPMNOEATMYDATA" ] && return
	# use if possible
	which eatmydata >/dev/null 2>/dev/null || return
424
	set_sudo
425
	# FIXME: check if SUDO already has eatmydata
426
	[ -n "$SUDO" ] && SUDO="$SUDO eatmydata" || SUDO="eatmydata"
427
	[ -n "$verbose" ] && info "Uwaga! eatmydata is installed, we will use it for disable all sync operations."
Vitaly Lipatov's avatar
Vitaly Lipatov committed
428
	return 0
429 430
}

431 432
# 
__get_package_for_command()
433
{
434
	case "$1" in
435
		equery|revdep-rebuild)
436
			echo 'gentoolkit'
437
			;;
438
		update-kernel|remove-old-kernels)
439
			echo 'update-kernel'
440 441 442 443
			;;
	esac
}

444 445 446 447 448 449 450 451 452 453 454 455 456 457 458
# TODO:
confirm() {
    local response
    # call with a prompt string or use a default
    read -r -p "${1:-Are you sure? [y/N]} " response
    case $response in
        [yY][eE][sS]|[yY])
            true
            ;;
        *)
            false
            ;;
    esac
}

459 460 461 462 463 464 465 466 467 468 469

confirm_info()
{
	info "$*"
	if [ -z "$non_interactive" ] ; then
		confirm "Are you sure? [y/N]" || fatal "Exiting"
	fi

}


470 471 472 473 474 475
is_root()
{
	local EFFUID="$(id -u)"
	[ "$EFFUID" = "0" ]
}

476 477
assure_root()
{
478
	is_root || fatal "run me only under root"
479 480 481 482 483 484 485 486 487
}

regexp_subst()
{
	local expression="$1"
	shift
	sed -i -r -e "$expression" "$@"
}

Vitaly Lipatov's avatar
Vitaly Lipatov committed
488
# TODO: we we can't use epm directly?
489 490 491
assure_exists()
{
	load_helper epm-assure
Vitaly Lipatov's avatar
Vitaly Lipatov committed
492
	local package="$2"
493
	local textpackage=
Vitaly Lipatov's avatar
Vitaly Lipatov committed
494
	[ -n "$package" ] || package="$(__get_package_for_command "$1")"
495
	[ -n "$3" ] && textpackage=" >= $3"
496
	( direct='' epm_assure "$1" $package $3 ) || fatal "Can't assure in '$1' command from $package$textpackage package"
497 498
}

499
# will replaced within disabled_eget in packaged version
Vitaly Lipatov's avatar
Vitaly Lipatov committed
500
eget()
501
{
502
	local EGET
503 504 505 506 507
	# use internal eget only if exists
	if [ -s $SHAREDIR/tools_eget ] ; then
		$SHAREDIR/tools_eget "$@"
		return
	fi
508
	fatal "Internal error: missed tools_eget"
509

510
	# FIXME: we need disable output here, eget can be used for get output
511
	assure_exists eget eget 3.3 >/dev/null
512 513 514 515 516
	# run external command, not the function
	EGET=$(which eget) || fatal "Missed command eget from installed package eget"
	$EGET "$@"
}

Vitaly Lipatov's avatar
Vitaly Lipatov committed
517 518 519 520 521 522 523 524 525 526 527 528 529 530
estrlist()
{
	if [ -s $SHAREDIR/tools_estrlist ] ; then
		$SHAREDIR/tools_estrlist "$@"
		return
	fi
	fatal "missed tools_estrlist"
}

onefile_estrlist()
{
	internal_tools_estrlist "$@"
}

531 532
# will replaced within eget() in packed version
onefile_eget()
Vitaly Lipatov's avatar
Vitaly Lipatov committed
533
{
534 535 536
	# check for both
	which curl 2>/dev/null >/dev/null || assure_exists wget
	which wget 2>/dev/null >/dev/null || assure_exists curl
537
	internal_tools_eget "$@"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
538 539
}

540
# TODO: improve and drop!
541 542 543
get_package_type()
{
	local i
544 545 546 547 548 549 550 551 552
	case $1 in
		*.deb)
			echo "deb"
			return
			;;
		*.rpm)
			echo "rpm"
			return
			;;
553 554 555 556 557 558 559 560
		*.txz)
			echo "txz"
			return
			;;
		*.tbz)
			echo "tbz"
			return
			;;
561 562 563 564
		*.exe)
			echo "exe"
			return
			;;
565 566 567 568
		*.msi)
			echo "msi"
			return
			;;
569 570 571 572
		*.AppImage)
			echo "AppImage"
			return
			;;
573 574 575 576 577 578 579
		*)
			#fatal "Don't know type of $1"
			# return package name for info
			echo "$1"
			return 1
			;;
	esac
580 581 582
}


583
# print options description from HELPCMD/HELPOPT lines in the code
584
# args: section_name, [file with code]
585 586
get_help()
{
587 588 589
    if [ "$0" = "/dev/stdin" ] || [ "$0" = "sh" ] ; then
        return
    fi
590
    local F="$0"
Vitaly Lipatov's avatar
Vitaly Lipatov committed
591 592 593
    if [ -n "$2" ] ; then
        is_dirpath "$2" && F="$2" || F="$(dirname $0)/$2"
    fi
594

595
    cat "$F" | grep -- "# $1" | while read -r n ; do
Vitaly Lipatov's avatar
Vitaly Lipatov committed
596 597 598 599 600 601
        if echo "$n" | grep -q "# $1: PART: " ; then
            echo
            echo "$n" | sed -e "s|# $1: PART: ||"
            continue
        fi
        echo "$n" | grep -q "^ *#" && continue
602 603 604
        opt=`echo $n | sed -e "s|) # $1:.*||g" -e 's|"||g' -e 's@^|@@'`
        desc=`echo $n | sed -e "s|.*) # $1:||g"`
        printf "    %-20s %s\n" "$opt" "$desc"
605 606 607
    done
}

608 609
# TODO: get all info by one request (too slow)
set_distro_info()
610
{
611
	# use external distro_info if internal one is missed
612
	DISTRVENDOR=$PROGDIR/distr_info
613
	[ -x $DISTRVENDOR ] || DISTRVENDOR=distro_info
614
	export DISTRVENDOR
615

616
	[ -n "$DISTRNAME" ] || DISTRNAME=$($DISTRVENDOR -d) || fatal "Can't get distro name."
617
	[ -n "$DISTRVERSION" ] || DISTRVERSION=$($DISTRVENDOR -v)
618
	if [ -z "$DISTRARCH" ] ; then
Vitaly Lipatov's avatar
Vitaly Lipatov committed
619
		DISTRARCH=$($DISTRVENDOR --distro-arch)
620
	fi
621
	DISTRCONTROL="$($DISTRVENDOR -y)"
622 623 624 625 626 627

	# TODO: improve BIGTMPDIR conception
	# https://bugzilla.mozilla.org/show_bug.cgi?id=69938
	# https://refspecs.linuxfoundation.org/FHS_3.0/fhs/ch05s15.html
	# https://geekpeach.net/ru/%D0%BA%D0%B0%D0%BA-systemd-tmpfiles-%D0%BE%D1%87%D0%B8%D1%89%D0%B0%D0%B5%D1%82-tmp-%D0%B8%D0%BB%D0%B8-var-tmp-%D0%B7%D0%B0%D0%BC%D0%B5%D0%BD%D0%B0-tmpwatch-%D0%B2-centos-rhel-7
	[ -n "$BIGTMPDIR" ] || [ -d "/var/tmp" ] && BIGTMPDIR="/var/tmp" || BIGTMPDIR="/tmp"
628 629 630 631 632 633 634
}

# FIXME: detect if not recognized
set_pm_type()
{
	local CMD
	set_distro_info
635 636
	set_target_pkg_env

637 638 639 640 641 642
# override package manager detection result
if [ -n "$FORCEPM" ] ; then
	PMTYPE=$FORCEPM
	return
fi

643
	PMTYPE="$($DISTRVENDOR -g $DISTRNAME/$DISTRVERSION)"
644
}
645

646 647
is_active_systemd()
{
648
	[ "$DISTRCONTROL" = "systemd" ]
649
}
650 651 652 653 654 655 656

assure_distr()
{
	local TEXT="this option"
	[ -n "$2" ] && TEXT="$2"
	[ "$DISTRNAME" = "$1" ] || fatal "$TEXT supported only for $1 distro"
}
657 658 659 660 661 662 663 664 665 666

# return delimiter sign in depend of package type
get_pkg_name_delimiter()
{
   local pkgtype="$1"
   [ -n "$pkgtype" ] || pkgtype="$($DISTRVENDOR -p)"

   [ "$pkgtype" = "deb" ] && echo "_" && return
   echo "-"
}
667 668 669

has_space()
{
670
    estrlist -- has_space "$@"
671
}
672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689

# compatibility layer
# add realpath if missed
if ! which realpath 2>/dev/null >/dev/null ; then
realpath()
{
    [ -n "$*" ] || return
    readlink -f "$@"
}
fi

# add subst if missed
if ! which subst 2>/dev/null >/dev/null ; then
subst()
{
    sed -i -e "$@"
}
fi